package cn.ischoolcode.javabook.scene9

/* 
 * 爱校码
 * http://www.ischoolcode.cn/
 *  
 * @author zcj
 */

import java.io.*;
import java.net.*;

public class ChatClient extends Thread{ 
  BufferedReader input;
  boolean socketAlive = true;
  ChatClient()
  {
  }

  public void run()
  {
     String dataFromSocket;
     try{
     // 从套接字读，然后写到屏幕
        while ((dataFromSocket = input.readLine()) != null) // Read from Socket
        {            
            System.out.println(dataFromSocket);
        }
     } 
     catch (IOException e)
     {
        System.out.println("Err: " +e);
     }
     // 它更容易为套接字阅读器来检测这个已离去的套接字。
     // 我们需要设置一个标志，以便套接字写入器知道什么时候放弃。     
     socketAlive = false;
     System.out.println("ChatClient线程终止(读取套接字 ---> 写到屏幕)");

  }
  void main_loop(String host, int port)
  {  
        Socket ChatSocket = null;
        PrintWriter out = null;
        BufferedReader keyboard =null;

        try 
        {
            ChatSocket = new Socket(host, port);
                      
            // 创建输入/输出与开放Socket关联的类

            out = new PrintWriter(ChatSocket.getOutputStream(), true);

            input = new BufferedReader(
                        new InputStreamReader(
                            ChatSocket.getInputStream()));
                       
            // 创建输入类的键盘

            keyboard = new BufferedReader(
                            new InputStreamReader(System.in));
           
            System.out.println("输入名称:");
            String name= keyboard.readLine();
            name = name +": ";

            String userInput, dataFromSocket;

            // 启动一个线程从套接字读取并将内容写到屏幕上 
            
            this.start();

            // 读取键盘，写的内容到套接字
            // 用在消息的前面加上名称。 
        
            while ((userInput = keyboard.readLine()) != null) //从套接字读
            {
                if ("quit".equals(userInput)) break;
                if (!socketAlive) break;
                out.println(name + userInput); // 写到套接字          
            }
        }
        catch (UnknownHostException e) 
        {
            System.err.println("Cant find host: "+ e);
            System.exit(1);
        } 
        catch (IOException e) 
        {
            System.err.println("Couldn't get I/O: " +e);
            System.exit(1);
        }
        finally
        {
            System.out.println("终止主ChatClient线程(键盘 - >套接字)");
            try{
                if (out != null)out.close(); // 关闭套接字的输出流
                if (input != null)input.close();  //  关闭套接字的输入流 
                if (keyboard != null)keyboard.close(); // 关闭键盘 
                if (ChatSocket != null)ChatSocket.close();  //关闭套接字
            }
            catch (IOException e){}
        }

  
  }

  public static void main(String[] args) throws IOException 
  {   
        ChatClient myChat = new ChatClient();
             
        if (args.length < 2)
        {
            System.out.println("用法:  java ChatClient 主机  端口号");
            return;
        }
        myChat.main_loop( args[0], Integer.parseInt(args[1]));
        
  }// 结束 main
}// 结束 ChatClient类



